% SAR - LEZ SVM for object recognition
% lezioni ispirate a http://www.vlfeat.org/applications/caltech-101-code.html
% Gli esercizi funzionano dopo aver installato il toolbox vlfeat-0.9.18 (e aver seguito il readme di installazione) e
% aver linkato correttamente il codice sottostante


clear all;
clc;
%close all

dire = 'E:\MATLAB\vlfeat-0.9.18\'
% addpath to the libsvm toolbox
eval(['run ',dire,'toolbox\vl_setup'])

eval(['cd ',dire,'\apps'])
% phow_caltech101()
% eval(['cd ',dire,'\apps\data'])



%% ESERCIZI
% Ogni volta che vado a provare una nuova configurazione, 
% devo cancellare tutti i mat finora creati nella directory data, a meno del mat dei 
% risultati!!! 

% Per ognuno degli esempi sottostanti, calcolarsi l'accuratezza
%1) eseguire il semplice BoW + SVM visto a lezione. Controllare gli input e gli output 
% di ogni singola funzione del main, senza andare dentro le singole funzioni.
% Provare a cambiare il numero di visual words, capendo come cambiano gli
% input e output nel codice

%2) visualizzare le visual words; per capire al volo cosa sono le sift, si
      % guardi http://docs.opencv.org/trunk/doc/py_tutorials/py_feature2d/py_sift_intro/py_sift_intro.html

%    PASSI:
%    
%    a) capire dove sono estratte nell'immagine le features salienti (SIFT)
%    b) capire qual'e' la grandezza del supporto spaziale (patch) che viene 
%     descritta dalla feature
%    c) capire, data una particolare feature, a che visual words essa faccia riferimento
%    d) prendere tutte le visual words (ovvero tutte la patch corrispondenti
%     ad una particolare visual word) di tutte le immagini usate come training,
%     e mediarle (una volta avendole trasformate in livelli di grigio)
%    e) costruire un collage di tutte le rappresentazioni di parole visuali cosi' 
%     calcolate 

% num_rounds = 1;
% sqr_num_sec = 2;
% num_class = 5;
% num_words = 300;
% cont = 0;
% phow_caltech101_2016_es2(num_words,sqr_num_sec,num_class) % visualizza le codewords 

% 3) Variare il numero di parole, fissando lo spatial histogram e osservare
% il variare delle performances

% num_rounds = 5;
% sqr_num_sec = 2;
% num_class = 5;
% num_words = [10,20,50,100,200,1000,2000];
% cont = 0;
% 
% for words = [num_words]
%     cont = cont +1;
%     fprintf('Numero parole:%i\n',words);
%     for i=1:num_rounds
%         accu(cont,i)=phow_caltech101es2_3(words,sqr_num_sec,num_class);
%     end
% end
% 
% stdres = std(accu,[],2);
% meanres = mean(accu,2);
% figure; errorbar(num_words,meanres,stdres);
% 3) aumentare la cardinalita' dei quadranti dello spatial histogram,
% provando varie iterazioni per ogni configurazione di parametri,
% calcolando la accuratezza media
% num_rounds = 5;
% num_words = 300;
% num_class = 7;
% sect = [1,2,3,4,5,10,20];
% cont = 0;
% 
% for sqr_num_sec = [sect]
%     cont = cont +1;
%     fprintf('Numero settori:%i\n',sqr_num_sec);
%     for i=1:num_rounds
%             accu(cont,i)=phow_caltech101es2_3(num_words,sqr_num_sec,num_class);
%     end
% end
% 
% stdres = std(accu,[],2);
% meanres = mean(accu,2);
% figure; errorbar(sect,meanres,stdres);

% 4)Analizzare l'espressivita' del vocabolario al variare delle immagini di
% partenza. Il quesito che ci si pone e' quello di avere un dizionario piu'
% espressivo avendo piu' immagini di partenza da usare per estrarre le
% sift. Per verificare questo fatto, si eseguano i seguenti passi:
% a) estrarre le sift da una partizione di training arbitraria
% b) proiettando le sift nel loro spazio 128 dimensionale, valutare media e
% matrice di covarianza delle features
% c) ripetere a) e b) un numero arbitrario N di volte (N=10) in modo tale
% da ottenere N medie e N matrici di covarianza
% d) analizzare la diversita delle medie e delle matrici di covarianza 
% (differenza lineare componente per componente)-> se la differenza e'
% alta, la partizione di partenza con cui estraggo le parole visuali e'
% importante, e dovro cambiare metodo di estrazione delle feature...

%by yourself!

%5) Costruzione di un vocabolario specifico per classe, ovvero fare in modo
%che il vocabolario finale abbia come parole visuali dei simboli estratti
%selettivamente da un training set per-classe, per ogni classe.

classesList = {'cougar_body','butterfly','crayfish','crocodile','dalmatian','Motorbikes'}

phow_caltech101cspec(classesList) % utilizza un vocabolario specifico per classe (Es 4 sotto)



